import Node from '../nodes/basic-types/Node';
import IEventInit from './IEventInit';
export default class Event {
    readonly bubbles: boolean;
    readonly cancelable: boolean;
    readonly composed: boolean;
    readonly currentTarget: Node;
    readonly target: Node;
    defaultPrevented: boolean;
    immediatePropagationStopped: boolean;
    type: string;
    /**
     * Constructor.
     *
     * @param {string} type Event type.
     * @param {IEventInit} eventInit Event init.
     */
    constructor(type: string, eventInit?: IEventInit);
    /**
     * Init event.
     *
     * @legacy
     */
    initEvent(): void;
    /**
     * Prevents default.
     */
    preventDefault(): void;
    /**
     * Stops immediate propagation.
     */
    stopImmediatePropagation(): void;
}
