import Node from '../nodes/basic-types/Node';
import IMutationObserverInit from './IMutationObserverInit';
import MutationRecord from './MutationRecord';
/**
 * The MutationObserver interface provides the ability to watch for changes being made to the DOM tree.
 *
 * @see https://developer.mozilla.org/en-US/docs/Web/API/MutationObserver
 */
export default class MutationObserverTest {
    private callback;
    private target;
    private listener;
    /**
     * Constructor.
     *
     * @param {function} callback Callback.
     */
    constructor(callback: (records: MutationRecord[]) => void);
    /**
     * Starts observing.
     *
     * @param {Node} target Target.
     * @param {IMutationObserverInit} options Options.
     */
    observe(target: Node, options: IMutationObserverInit): void;
    /**
     * Disconnects.
     */
    disconnect(): void;
    /**
     * Takes records.
     */
    takeRecords(): [];
}
